create or replace
PROCEDURE ETL_MPCOTACAO(P_DTINI IN DATE,
                        P_DTFIN IN DATE)
IS
  V_DTINI DATE;
  V_DTFIN DATE;
  V_ANO      VARCHAR2(04);
  V_MES      VARCHAR2(02);
  V_COUNTER  NUMBER;
BEGIN

   V_DTINI :=  TO_DATE(TO_CHAR(P_DTINI,'DD/MM/YYYY'),'DD/MM/YYYY');
   V_DTFIN :=  TO_DATE(TO_CHAR(P_DTFIN,'DD/MM/YYYY'),'DD/MM/YYYY');
   
   V_DTINI := next_day(V_DTINI-7, 'Domingo');
        
        FOR C_REG IN(SELECT ROWID DEL FROM DM_MPCOTACAO 
                           WHERE to_date(DTINIVALITM,'dd/mm/yy') >= to_date(V_DTINI,'dd/mm/yy')
                             AND to_date(DTFINVALITM,'dd/mm/yy') <= to_date(V_DTFIN,'dd/mm/yy')) LOOP
        V_COUNTER := V_COUNTER +1;
                     
         DELETE FROM DM_MPCOTACAO 
               WHERE C_REG.DEL = ROWID;
         
         IF V_COUNTER >= 1000 THEN
            COMMIT;
            V_COUNTER := 0;
         END IF;
        END LOOP; 
     COMMIT;
                 
         FOR C_REGIAO IN(SELECT CDREGIAO, NMREGIAO, SGESTADO 
                           FROM REGIAO) LOOP
        
            FOR C_DATA IN(SELECT DISTINCT DTMES DTINI, LAST_DAY(DTDATA) DTFIM, 
                                TO_CHAR(DTDATA,'MM') CDMES, 
                                TO_CHAR(DTDATA,'YYYY') CDANO
                                
                           FROM DATA
                          WHERE DTDATA BETWEEN V_DTINI AND V_DTFIN
                          ORDER BY DTMES) LOOP 
        

                   FOR C_ITEMCOLE IN (SELECT (to_char(trunc(ITEMCOLE.DTINIVALITM),'dd/mm/yyyy')||' - '||to_char(trunc(ITEMCOLE.DTFINVALITM),'dd/mm/yyyy')) DSVALIDADE,
                                              ITEMCOLE.DTINIVALITM, ITEMCOLE.DTFINVALITM ,
                                              ITEMCOLE.CDFORNECED,
                                              ITEMCOLE.CDMARCA,
                                              COLETAPR.CDOPERADOR,
                                              ITEMCOLE.CDPRODUTO,
                                              PRODUTO.CDPRODESTO,
                                              ROUND((ITEMCOLE.VRPRECUNIITM/PRODUTO.VRFATOCONV),3) VRUNIT,
                                              ROUND((ITEMCOLE.VRPRECECOITM/PRODUTO.VRFATOCONV),3) VRECON,
                                              ROUND((ITEMCOLE.VRPRECOITMPI/PRODUTO.VRFATOCONV),3) VRECONPI
                                        FROM ITEMCOLE, PRODUTO, COLETAPR
                                       WHERE ITEMCOLE.DTINIVALITM >= C_DATA.DTINI 
                                         AND ITEMCOLE.DTFINVALITM <= C_DATA.DTFIM
                                         AND (ITEMCOLE.VRPRECUNIITM <> 0 AND ITEMCOLE.VRPRECECOITM  <> 0)
                                         AND ITEMCOLE.CDREGIAO       = C_REGIAO.CDREGIAO
                                         AND ITEMCOLE.CDPRODUTO      = PRODUTO.CDPRODUTO
                                         AND ITEMCOLE.CDFILIAL       = COLETAPR.CDFILIAL
                                         AND ITEMCOLE.NRCOLEPRECO    = COLETAPR.NRCOLEPRECO                
                                       ORDER BY ITEMCOLE.DTINIVALITM)LOOP
                   
          
                      
                      INSERT INTO DM_MPCOTACAO
                                  (CDANOBI,
                                   CDMESBI,
                                   DTINIVALITM,
                                   DTFINVALITM,
                                   DSVALIDADE,
                                   CDREGIAO,
                                   CDFORNECED,
                                   CDMARCA,
                                   CDCOMPRADOR,
                                   CDPRODCMP,
                                   CDPRODESTO,
                                   VRUNIT,
                                   VRECON,
                                   VRECONPI
                                   )
                            
                            VALUES
                            
                                  (C_DATA.CDANO,
                                   C_DATA.CDMES,
                                   TO_DATE(C_ITEMCOLE.DTINIVALITM,'DD/MM/YYYY'),
                                   TO_DATE(C_ITEMCOLE.DTFINVALITM,'DD/MM/YYYY'),
                                   C_ITEMCOLE.DSVALIDADE,
                                   C_REGIAO.CDREGIAO,
                                   C_ITEMCOLE.CDFORNECED,
                                   C_ITEMCOLE.CDMARCA,
                                   C_ITEMCOLE.CDOPERADOR,
                                   C_ITEMCOLE.CDPRODUTO,
                                   C_ITEMCOLE.CDPRODESTO,
                                   C_ITEMCOLE.VRUNIT,
                                   C_ITEMCOLE.VRECON,
                                   C_ITEMCOLE.VRECONPI
                                   );
                                   
                                   commit;
                                  
                   END LOOP;--LOOP DE ITEMCOLE 
    
           END LOOP;--LOOP DE REGIAO         
      
      END LOOP;--LOOP DE DATA
   
END;
/
begin
CRIA_FATOS('DM_MPCOTACAO', 'VRUNIT',	  'Vr. Unit.',  	     'Valor Unitrio',				         'Mapa de Cotaes');
CRIA_FATOS('DM_MPCOTACAO', 'VRECON',	  'Vr. Econ.',  	     'Valor Econmico',				        'Mapa de Cotaes');
CRIA_FATOS('DM_MPCOTACAO', 'VRECONPI',	'Vr. Econ. PI/DSV', 'Valor Econmico com PI/DSV',	'Mapa de Cotaes');

CRIA_DIME('DM_MPCOTACAO',  'CDFORNECED',  'Fornecedor', 'FORNECEDOR', 'CDFORNECED', 'NMFANTFORN',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDREGIAO',    'Regio',        'REGIAO', 'CDREGIAO', 'NMREGIAO',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDPRODESTO',  'Prod. Estoque', 'PRODUTO', 'CDPRODUTO', 'NMPRODUTO',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDMARCA',     'Marca', 'MARCA', 'CDMARCAR', 'NMMARCA',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDPRODCMP',   'Prod. Compra', 'PRODUTO', 'CDPRODUTO', 'NMPRODUTO',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDCOMPRADOR', 'Comprador', 'OPERADOR', 'CDOPERADOR', 'NMOPERADOR',     NULL);
CRIA_DIME('DM_MPCOTACAO',  'DSVALIDADE',  'Val. Cotao', NULL, NULL, NULL,     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDSEMANA',    'Semana', NULL, NULL, NULL,     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDMESBI',       'Ms', NULL, NULL, NULL,     NULL);
CRIA_DIME('DM_MPCOTACAO',  'CDANOBI',       'Ano', NULL, NULL, NULL,     NULL);
end;
/
DECLARE
   V_CDSEQUENCIAL VARCHAR2(20) NULL;
BEGIN
    SELECT COUNT(*)
    INTO   V_CDSEQUENCIAL
    FROM   EVENTOAEV
    WHERE  NMOBJBDEVEN = 'ETL_MPCOTACAO';

    IF V_CDSEQUENCIAL = 0 THEN     --> S ADICIONA A PROCEDURE SE ELA NO EXISTIR AINDA NO CADASTRO
        BEGIN
            SELECT LPAD(NVL(MAX(LPAD(CDEVENTOAEV,10,'0'))+1,0),10,'0')
            INTO   V_CDSEQUENCIAL
            FROM   EVENTOAEV;

            INSERT INTO EVENTOAEV
            (CDEVENTOAEV, NMEVENTOAEV, IDTPEVENAEV, CDOPERINCL, DTINCLEVEN, NMOBJBDEVEN)
            VALUES
            (V_CDSEQUENCIAL,'Mapa de Cotao','STP',NULL,SYSDATE,'ETL_MPCOTACAO');

            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN)
            VALUES
            (V_CDSEQUENCIAL,'P_DTINI','D','E','Data Inicial','N',0,'01');

            INSERT INTO PARAMEVENTO
            (CDEVENTOAEV,NMPARAMEVEN,IDDADPARAMEVEN,IDTIPPARAMEVEN,DSPARAMEVEN,IDPARAMNULL,VRTAMPARAM,NRSEQPARAMEVEN)
            VALUES
            (V_CDSEQUENCIAL,'P_DTFIN','D','E','Data Final','N',0,'02');

            COMMIT;
        EXCEPTION
           WHEN OTHERS THEN
              RAISE_APPLICATION_ERROR (-20001,'Falha no cadastro de eventos agendveis.');
        END;
    END IF;
END;
/



 